/*
 * (c) Peter Mueller, 2008 - 2018
 *
 * All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden.
 */

/* Command line options: -U codegen.config -p SSC -l cx -o tl_sm tl_sm.xml   */
/* This file is generated from tl_sm.xml - do not edit manually*/
/* Generated on: Wed Dec 04 11:51:35 CET 2019 / version 4.01 */


#ifndef __TL_SM_H__
#define __TL_SM_H__


/* Header to define simple data types */
#include <stdint.h>

/* State definitions */
typedef enum{
	Dummy,
	__TL_SM_LAST_STATE__} TL_SM_STATES_T;






/* Predefined types required by the codegen. You can provide your own  */
/* definitions by setting the following define somewhere in your built env. */
#ifndef __PROVIDE_OWN_TL_SM_STATEMACHINE_TYPES__
	typedef uint8_t TL_SM_ENTRY_FLAG_T;
	typedef TL_SM_STATES_T TL_SM_STATEVAR_T;
	typedef uint8_t TL_SM_INST_ID_T;
	typedef uint8_t TL_SM_EV_CONSUMED_FLAG_T ;
#endif




/* Instance data definition of state machine */
typedef struct{
	TL_SM_ENTRY_FLAG_T dummyEntry;
	TL_SM_STATEVAR_T stateVar;
		TL_SM_INST_ID_T inst_id;
} TL_SM_INSTANCEDATA_T;

/* Helper to initialize the machine's instance data */
#define TL_SM_INSTANCEDATA_INIT {\
	1,\
	(TL_SM_STATEVAR_T) Dummy /* set init state of top state */,\
	0 /* instance id */ } 

/* Region handler prototypes  */

/*Prototype of the state machine function */
void  tl_sm(TL_SM_INSTANCEDATA_T *instanceVar, TL_SM_EVENT_T msg);


/*Prototoye of the reset machine function */
void tl_smResetMachine(TL_SM_INSTANCEDATA_T *instanceVar);

// Helper(s) to find out if the machine is in a certain state
uint8_t tl_smIsInDummy(TL_SM_INSTANCEDATA_T *instanceVar);


/* Macros to test if the machine is in a certain state. */
#define TL_SM_IS_IN_DUMMY(instance)((((&instance)->stateVar==Dummy)) ? (1U) : (0U))


/* Helper returning the innermost active state.*/
TL_SM_STATES_T tl_smGetInnermostActiveState(TL_SM_INSTANCEDATA_T *instanceVar);

#endif
